Index: /branches/PublicaMundi_David-devel/docs/contribute/doc.rst
===================================================================
--- /branches/PublicaMundi_David-devel/docs/contribute/doc.rst	(revision 716)
+++ /branches/PublicaMundi_David-devel/docs/contribute/doc.rst	(revision 717)
@@ -5,5 +5,5 @@
 
 Contribute documentation
-==================
+========================
 
 ZOO Documentation is a collaborative process managed by the ZOO developers. Anybody is welcome to contribute to the ZOO-Project documentation. Please consider the following instructions before doing so.
@@ -11,4 +11,18 @@
 General information
 ------------------------
+
+Heading syntaxe
+...............
+
+Tere are various title heading used in the documentation, when you
+create a new document, you're invited to follow the following heading
+underline syntaxe:
+
+ * for Heading 1, use ``=``,
+ *  for Heading 2, use ``-``,
+ *  for Heading 3, use ``.``,
+ *  for Heading 4, use ``*``,
+ *  for Heading 5, use ``#``.
+ 
 
 For new comers
@@ -38,5 +52,5 @@
 
 Installing and using Sphinx
-------------------------
+---------------------------
 
 On Linux
Index: /branches/PublicaMundi_David-devel/docs/contribute/index.rst
===================================================================
--- /branches/PublicaMundi_David-devel/docs/contribute/index.rst	(revision 716)
+++ /branches/PublicaMundi_David-devel/docs/contribute/index.rst	(revision 717)
@@ -2,7 +2,10 @@
 
 Contributor Guide
-=============
+=================
 
-This is the `ZOO-Project <http://zoo-project.org>`__ **Contributor Guide**. This document provides information and guidelines to anyone willing to contribute to the `ZOO-Project <http://zoo-project.org>`__ open source software project and help making it better.
+This is the `ZOO-Project <http://zoo-project.org>`__ **Contributor
+Guide**. This document provides information and guidelines to anyone
+willing to contribute to the `ZOO-Project <http://zoo-project.org>`__
+open source software project and help making it better.
 
 .. toctree::
@@ -12,5 +15,4 @@
    code
    doc
-   translate
    dev
    release
Index: anches/PublicaMundi_David-devel/docs/contribute/translate.rst
===================================================================
--- /branches/PublicaMundi_David-devel/docs/contribute/translate.rst	(revision 716)
+++ 	(revision )
@@ -1,83 +1,0 @@
-.. _contribute_trans:
-
-Contribute translation
-===============
-
-Anybody can take part to the `ZOO-Project <http://zoo-project.org>`__ translation and is welcome to:
-
- * Translate ZOO-Services configuration files
-   
- * Translate documentation
-   
-
-ZCFG translation
---------------------------
-
-First of all, use the following commands from your Services Provider directory in order to extract all the messages to translate from the ZCFG files :
-
-  ::
-  
-      #!/bin/bash
-      for j in cgi-env/*zcfg ; 
-        do 
-          for i in Title Abstract; 
-           do
-            grep $i $j | sed "s:$i = :_ss(\":g;s:$:\"):g" ;
-           done;
-       done > locale/.cache/my_service_string_to_translate.c
-   
-
-Then generate the 'messages.po' file based on the Services Provider source code using the following command :
-
-  ::
-  
-      #!/bin/bash
-      xgettext service.c locale/.cache/my_service_string_to_translate.c -o message.po -p locale/po/ -k_ss
-
-Once 'messages.po' is created, use the following command to create the po file for the targeted language for translation. We will use the French language here as an example :
-
-  ::
-  
-      #!/bin/bash
-      cd locale/po/
-      msginit -i messages.po -o zoo_fr_FR.po -l fr
-
-Edit the zoo_fr_FR.po file with your favorite text editor or using one of the following tools :
-
- * `poedit <http://www.poedit.net/>`__
- * `virtaal <http://translate.sourceforge.net/wiki/virtaal/index>`__
- * `transifex <https://www.transifex.net/>`__
- 
-Once the zoo_fr_FR.po file is completed, you can generate and install the corresponding *mo* file using the following command : 
-
-  ::
-  
-      #!/bin/bash
-      msgfmt locale/po/zoo_fr_FR.po -o /usr/share/locale/fr/LC_MESSAGES/zoo-services.mo
-
-
-In order to test the Services Provider ZCFG and internal messages
-translation, please add the language argument to you request. As an
-example, such a request:
-
-http://youserver/cgi-bin/zoo_loader.cgi?request=GetCapabilities&service=WPS
-
-would become the following:
-
-http://youserver/cgi-bin/zoo_loader.cgi?request=GetCapabilities&service=WPS&language=fr-FR
-
-The following command may also be useful in order to pull all the translations already available for a specific language.
-
-  ::
-  
-      #!sh
-      msgcat -o compilation.po $(find ../../ -name fr_FR.utf8.po)
-      msgfmt compilation.po -o /usr/share/locale/fr/LC_MESSAGES/zoo-services.mo
-
-
-Documentation translation
---------------------------
-
-Translate the `ZOO-Project <http://zoo-project.org>`__ documentation in your language !
-
-Please refer to the :ref:`<contribute_doc>` section to learn more. 
Index: /branches/PublicaMundi_David-devel/docs/install/download.rst
===================================================================
--- /branches/PublicaMundi_David-devel/docs/install/download.rst	(revision 716)
+++ /branches/PublicaMundi_David-devel/docs/install/download.rst	(revision 717)
@@ -7,5 +7,22 @@
 
 .. warning::
-    The ZOO-Project svn is the place where developement happens. Checking out svn is the best way to be always up to date.
+    The ZOO-Project svn is the place where developement
+    happens. Checking out svn is the best way to be always up-to-date.
+
+
+ZOO-Project releases archives
+-------------------------------
+
+Each new `ZOO-Project <http://zoo-project.org>`_ major release are
+available on the project official website as .zip and .tar.bz2
+archives. Head to the `Downloads
+<http://zoo-project.org/site/Downloads>`_ section to get the latest or
+older ZOO-Project releases. 
+
+.. warning::
+    Don't use older versions of ZOO-Project if you want to use new
+    features and avoid older code issues. Prefer svn or github
+    instead.
+
 
 
@@ -29,14 +46,7 @@
   
 .. note::
-    The ZOO-Project svn server listens on the 1046 (1024+22) portvb(instead of 22 by default), so please use a specific tunnel to access the svn server, as shown in the command above.
-
-
-ZOO-Project releases archives
--------------------------------
-
-Each new `ZOO-Project <http://zoo-project.org>`_ major release is also made available on the project official website as .zip and .tar.bz2 archives. Head to the `Download <http://zoo-project.org/Code/Download>`_ section to get the latest or older ZOO-Project releases. 
-
-.. warning::
-    Don't use older versions of ZOO-Project if you want to use new features and avoid older code issues. Prefer svn or github instead.
+    The ZOO-Project svn server listens on the 1046 (1024+22) port
+    (instead of 22 by default), so please use a specific tunnel to
+    access the svn server, as shown in the command above.
 
 ZOO-Project Github
Index: /branches/PublicaMundi_David-devel/docs/install/installation.rst
===================================================================
--- /branches/PublicaMundi_David-devel/docs/install/installation.rst	(revision 716)
+++ /branches/PublicaMundi_David-devel/docs/install/installation.rst	(revision 717)
@@ -370,4 +370,26 @@
     the ``--with-wx-config``  to specify its location.
 
+Translation support (Optional)
+******************************
+
+The ZOO-Kernel is able to translate the messages it produce in different
+natural languages. For this translation support to work, you have to
+generate and install manually the quested files on your system, by
+using the following command:
+
+.. code::
+
+    msgfmt zoo-project/zoo-kernel/locale/po/fr_FR.utf8.po -o /usr/share/locale/fr/LC_MESSAGES/zoo-kernel.mo
+
+The ZOO-Kernel is also able to handle translation of
+ZOO-Services. Please, refer to :ref:`this document
+<service_translation>` for more details on the procedure to add new
+ZOO-Service translation files.
+
+.. warning::
+    The location of the final ``.mo`` file may vary depending on your
+    system setup.
+
+
 Install ZOO-Services
 --------------------
Index: /branches/PublicaMundi_David-devel/docs/services/debug.rst
===================================================================
--- /branches/PublicaMundi_David-devel/docs/services/debug.rst	(revision 716)
+++ /branches/PublicaMundi_David-devel/docs/services/debug.rst	(revision 717)
@@ -86,5 +86,10 @@
   run "service=wps&version=1.0.0&request=execute&identifier=HelloPy&datainputs=a=your name&responsedocument=Result"
 
-At this point you can ask help at the `ZOO mailing list <http://lists.osgeo.org/cgi-bin/mailman/listinfo/zoo-discuss>`_
+.. note::
+    You can use the same parameter used before to simulate POST
+    requests when running from gdb.
+
+If nothing helped, you can ask help at the `ZOO mailing list
+<http://lists.osgeo.org/cgi-bin/mailman/listinfo/zoo-discuss>`_
 copying the result of the command.
 
Index: /branches/PublicaMundi_David-devel/docs/services/index.rst
===================================================================
--- /branches/PublicaMundi_David-devel/docs/services/index.rst	(revision 716)
+++ /branches/PublicaMundi_David-devel/docs/services/index.rst	(revision 717)
@@ -16,4 +16,5 @@
    process-profiles
    howtos
+   translation
    status
    debug
Index: /branches/PublicaMundi_David-devel/docs/services/translation.rst
===================================================================
--- /branches/PublicaMundi_David-devel/docs/services/translation.rst	(revision 717)
+++ /branches/PublicaMundi_David-devel/docs/services/translation.rst	(revision 717)
@@ -0,0 +1,84 @@
+.. _service_translation:
+
+Translation Support
+===================
+
+ZOO-Kernel support translating internal messages it emits but it can
+also translate both the metadata informations stored in the ZCFG file
+and the messages emitted by the ZOO-Service itself. This document show
+how to create the files required to handle such a translation process
+for the ZOO-Services.
+
+
+ZCFG translation
+--------------------------
+
+First of all, use the following commands from your Services Provider
+directory in order to extract all the messages to translate from the
+ZCFG files :
+
+  ::
+  
+      #!/bin/bash
+      mkdir -p locale/{po,.cache}
+      for j in cgi-env/*zcfg ; 
+        do 
+          for i in Title Abstract; 
+           do
+            grep $i $j | sed "s:$i = :_ss(\":g;s:$:\"):g" ;
+           done;
+       done > locale/.cache/my_service_string_to_translate.c
+   
+
+Then generate the 'messages.po' file based on the Services Provider
+source code (located in ``service.c`` in this example) using the
+following command:
+
+  ::
+  
+      #!/bin/bash
+      xgettext service.c locale/.cache/my_service_string_to_translate.c -o message.po -p locale/po/ -k_ss
+
+Once 'messages.po' is created, use the following command to create the
+``.po`` file for the targeted language to translate into. We will use the
+French language here as an example:
+
+  ::
+  
+      #!/bin/bash
+      cd locale/po/
+      msginit -i messages.po -o zoo_fr_FR.po -l fr
+
+Edit the ``zoo_fr_FR.po`` file with your favorite text editor or using
+one of the following tools:
+
+ * `poedit <http://www.poedit.net/>`__
+ * `virtaal <http://translate.sourceforge.net/wiki/virtaal/index>`__
+ * `transifex <https://www.transifex.net/>`__
+ 
+Once the ``zoo_fr_FR.po`` file is completed, you can generate and
+install the corresponding ``.mo`` file using the following command:
+
+  ::
+  
+      #!/bin/bash
+      msgfmt locale/po/zoo_fr_FR.po -o /usr/share/locale/fr/LC_MESSAGES/zoo-services.mo
+
+
+In order to test the Services Provider ZCFG and internal messages
+translation, please add the language argument to you request. As an
+example, such a request:
+
+http://youserver/cgi-bin/zoo_loader.cgi?request=GetCapabilities&service=WPS
+
+would become the following:
+
+http://youserver/cgi-bin/zoo_loader.cgi?request=GetCapabilities&service=WPS&language=fr-FR
+
+The following command may also be useful in order to pull all the translations already available for a specific language.
+
+  ::
+  
+      #!sh
+      msgcat -o compilation.po $(find ../../ -name fr_FR.utf8.po)
+      msgfmt compilation.po -o /usr/share/locale/fr/LC_MESSAGES/zoo-services.mo