Index: trunk/zoo-project/zoo-client/lib/tpl/payload_Execute.mustache
===================================================================
--- trunk/zoo-project/zoo-client/lib/tpl/payload_Execute.mustache	(revision 752)
+++ trunk/zoo-project/zoo-client/lib/tpl/payload_Execute.mustache	(revision 753)
@@ -2,53 +2,51 @@
 ../wpsExecute_request.xsd" language="{{language}}">
   <!-- template-version: 0.21 -->
-	<ows:Identifier>{{Identifier}}</ows:Identifier>
-	<wps:DataInputs>
+  <ows:Identifier>{{Identifier}}</ows:Identifier>
+  <wps:DataInputs>
 {{#DataInputs}}
 {{#is_literal}}
-		<wps:Input>
-			<ows:Identifier>{{identifier}}</ows:Identifier>
-			<wps:Data>
-				<wps:LiteralData{{#dataType}} dataType="{{dataType}}"{{/dataType}}>{{value}}</wps:LiteralData>
-			</wps:Data>
-		</wps:Input>
+    <wps:Input>
+      <ows:Identifier>{{identifier}}</ows:Identifier>
+      <wps:Data>
+        <wps:LiteralData{{#dataType}} dataType="{{dataType}}"{{/dataType}}>{{value}}</wps:LiteralData>
+      </wps:Data>
+    </wps:Input>
 {{/is_literal}}
 {{#is_bbox}}
-		<wps:Input>
-			<ows:Identifier>{{identifier}}</ows:Identifier>
-			<wps:Data>
-				<wps:BoundingBoxData ows:crs="{{crs}}" ows:dimensions="{{dimension}}">
-            <ows:LowerCorner>{{lowerCorner}}</ows:LowerCorner>
-            <ows:UpperCorner>{{upperCorner}}</ows:UpperCorner>
-         </wps:BoundingBoxData>
-			</wps:Data>
-		</wps:Input>
+    <wps:Input>
+      <ows:Identifier>{{identifier}}</ows:Identifier>
+      <wps:Data>
+        <wps:BoundingBoxData ows:crs="{{crs}}" ows:dimensions="{{dimension}}">
+          <ows:LowerCorner>{{lowerCorner}}</ows:LowerCorner>
+          <ows:UpperCorner>{{upperCorner}}</ows:UpperCorner>
+        </wps:BoundingBoxData>
+      </wps:Data>
+    </wps:Input>
 {{/is_bbox}}
 {{#is_complex}}
 {{#is_reference}}
 {{#is_get}}
-		<wps:Input>
-			<ows:Identifier>{{identifier}}</ows:Identifier>
-			<wps:Reference xlink:href="{{href}}"{{#schema}} schema="{{shema}}"{{/schema}}{{#mimeType}} mimeType="{{mimeType}}"{{/mimeType}}{{#encoding}} encoding="{{encoding}}"{{/encoding}}/>
-		</wps:Input>
+    <wps:Input>
+      <ows:Identifier>{{identifier}}</ows:Identifier>
+      <wps:Reference xlink:href="{{href}}"{{#schema}} schema="{{shema}}"{{/schema}}{{#mimeType}} mimeType="{{mimeType}}"{{/mimeType}}{{#encoding}} encoding="{{encoding}}"{{/encoding}}/>
+    </wps:Input>
 {{/is_get}}
 {{#is_post}}
-		<wps:Input>
-			<ows:Identifier>{{identifier}}</ows:Identifier>
-			<wps:Reference xlink:href="{{href}}" method="{{method}}" {{#schema}} schema="{{shema}}"{{/schema}}{{#mimeType}} mimeType="{{mimeType}}"{{/mimeType}}{{#encoding}} encoding="{{encoding}}"{{/encoding}}>
+    <wps:Input>
+      <ows:Identifier>{{identifier}}</ows:Identifier>
+      <wps:Reference xlink:href="{{href}}" method="{{method}}" {{#schema}} schema="{{shema}}"{{/schema}}{{#mimeType}} mimeType="{{mimeType}}"{{/mimeType}}{{#encoding}} encoding="{{encoding}}"{{/encoding}}>
 {{#headers}}
-			  <wps:Header key="{{key}}" value="{{value}}" />
+        <wps:Header key="{{key}}" value="{{value}}" />
 {{/headers}}
-			  <wps:Body>{{{value}}}</wps:Body>
-			</wps:Reference>
-		</wps:Input>
+        <wps:Body>{{{value}}}</wps:Body>
+      </wps:Reference>
+    </wps:Input>
 {{/is_post}}
 {{/is_reference}}
 {{^is_reference}}
-		<wps:Input>
+    <wps:Input>
       <ows:Identifier>{{identifier}}</ows:Identifier>
       <wps:Data>
-        <wps:ComplexData{{#schema}} schema="{{shema}}"{{/schema}}{{#mimeType}} mimeType="{{mimeType}}"{{/mimeType}}{{#encoding}} encoding="{{encoding}}"{{/encoding}}>{{#is_XML}}
-	 {{{value}}}{{/is_XML}}{{^is_XML}}<![CDATA[{{{value}}}]]>{{/is_XML}}
-        </wps:ComplexData>
+        <wps:ComplexData{{#schema}} schema="{{shema}}"{{/schema}}{{#mimeType}} mimeType="{{mimeType}}"{{/mimeType}}{{#encoding}} encoding="{{encoding}}"{{/encoding}}>{{#is_XML}}{{{value}}}{{/is_XML}}{{^is_XML}}<![CDATA[{{{value}}}]]>{{/is_XML}}</wps:ComplexData>
       </wps:Data>
     </wps:Input>
@@ -56,6 +54,6 @@
 {{/is_complex}}
 {{/DataInputs}}
-	</wps:DataInputs>	
-	<wps:ResponseForm>
+  </wps:DataInputs>	
+  <wps:ResponseForm>
 {{#RawDataOutput}}
 {{#DataOutputs}}