Index: /trunk/zoo-project/zoo-kernel/locale/po/fr_FR.po
===================================================================
--- /trunk/zoo-project/zoo-kernel/locale/po/fr_FR.po	(revision 794)
+++ /trunk/zoo-project/zoo-kernel/locale/po/fr_FR.po	(revision 795)
@@ -11,5 +11,5 @@
 "Report-Msgid-Bugs-To: zoo-discuss@lists.osgeo.org\n"
 "POT-Creation-Date: 2015-07-02 18:06+0200\n"
-"PO-Revision-Date: 2016-01-15 15:13+0000\n"
+"PO-Revision-Date: 2016-11-15 09:11+0000\n"
 "Last-Translator: Gérald FENOY <gerald.fenoy@geolabs.fr>\n"
 "Language-Team: French (France) (http://www.transifex.com/zoo-project/zoo-kernel-internationalization/language/fr_FR/)\n"
@@ -124,5 +124,5 @@
 "background task. Please access the URL in the statusLocation attribute "
 "provided in this document to get the up-to-date status and results."
-msgstr "Le service \"%s\" a été accepté par le ZOO-Kernel et est en cours d'exécution en tâche de fond. Merci d'utiliser le lien URL fournis dans l'attribut statusLocation de la racine de ce document pour obtenir des information sur l'état d'éxcution du service."
+msgstr "Le service \"%s\" a été accepté par le ZOO-Kernel et est en cours d'exécution en tâche de fond. Merci d'utiliser le lien URL fournis dans l'attribut statusLocation de la racine de ce document pour obtenir des informations sur l'état d'éxcution du service."
 
 #: response_print.c:1661
@@ -244,5 +244,5 @@
 "%s \n"
 " Unable to run your python process properly. Unable to provide any further information."
-msgstr "%s\nImpossible de charger votre service python correctement. Aucune information supplémentaire."
+msgstr "%s\nImpossible d'exécuter votre servce Python correctement. Impossible de fournir plus d'informations."
 
 #: zoo_service_loader.c:352
@@ -254,5 +254,5 @@
 #, c-format
 msgid "Error occurred while running the %s function: %s"
-msgstr "Une erreur est survenue pendant l'execution de la %s fonction: %s"
+msgstr "Une erreur s'est produite lors de l'exécution de la fonction %s : %s"
 
 #: zoo_service_loader.c:578
@@ -276,4 +276,8 @@
 msgstr "Impossible de charger le fichier main.cfg."
 
+#: zoo_service_loader.c:895
+msgid "%s The following file: %s cannot be found."
+msgstr "%s Le fichier : %s ne peut pas être trouvé."
+
 #: zoo_service_loader.c:940
 #, c-format
Index: /trunk/zoo-project/zoo-kernel/locale/po/it_IT.po
===================================================================
--- /trunk/zoo-project/zoo-kernel/locale/po/it_IT.po	(revision 794)
+++ /trunk/zoo-project/zoo-kernel/locale/po/it_IT.po	(revision 795)
@@ -10,6 +10,6 @@
 "Report-Msgid-Bugs-To: zoo-discuss@lists.osgeo.org\n"
 "POT-Creation-Date: 2015-07-02 18:06+0200\n"
-"PO-Revision-Date: 2015-09-30 10:04+0000\n"
-"Last-Translator: Luca Delucchi <lucadeluge@gmail.com>\n"
+"PO-Revision-Date: 2016-06-30 09:31+0000\n"
+"Last-Translator: Gérald FENOY <gerald.fenoy@geolabs.fr>\n"
 "Language-Team: Italian (Italy) (http://www.transifex.com/zoo-project/zoo-kernel-internationalization/language/it_IT/)\n"
 "MIME-Version: 1.0\n"
@@ -243,5 +243,5 @@
 "%s \n"
 " Unable to run your python process properly. Unable to provide any further information."
-msgstr "%s\nImpossibile eseguire il processo di Python correttamente. Impossibile fornire ulteriori informazioni."
+msgstr ""
 
 #: zoo_service_loader.c:352
@@ -253,5 +253,5 @@
 #, c-format
 msgid "Error occurred while running the %s function: %s"
-msgstr "Un errore è avvenuto mentre si stava eseguendo la funzione %s: %s"
+msgstr ""
 
 #: zoo_service_loader.c:578
@@ -275,4 +275,8 @@
 msgstr "Impossibile caricare il file main.cfg"
 
+#: zoo_service_loader.c:895
+msgid "%s The following file: %s cannot be found."
+msgstr ""
+
 #: zoo_service_loader.c:940
 #, c-format
Index: /trunk/zoo-project/zoo-kernel/locale/po/ja_JP.po
===================================================================
--- /trunk/zoo-project/zoo-kernel/locale/po/ja_JP.po	(revision 794)
+++ /trunk/zoo-project/zoo-kernel/locale/po/ja_JP.po	(revision 795)
@@ -6,4 +6,5 @@
 # Nicolas Bozon <nicolas.bozon@gmail.com>, 2015
 # 林博文 <pica.hayashi@gmail.com>, 2015
+# 林博文 <pica.hayashi@gmail.com>, 2016
 msgid ""
 msgstr ""
@@ -11,6 +12,6 @@
 "Report-Msgid-Bugs-To: zoo-discuss@lists.osgeo.org\n"
 "POT-Creation-Date: 2015-07-02 18:06+0200\n"
-"PO-Revision-Date: 2015-08-30 11:30+0000\n"
-"Last-Translator: 林博文 <pica.hayashi@gmail.com>\n"
+"PO-Revision-Date: 2016-06-30 09:31+0000\n"
+"Last-Translator: Gérald FENOY <gerald.fenoy@geolabs.fr>\n"
 "Language-Team: Japanese (Japan) (http://www.transifex.com/zoo-project/zoo-kernel-internationalization/language/ja_JP/)\n"
 "MIME-Version: 1.0\n"
@@ -276,4 +277,8 @@
 msgstr "main.cfg ファイルをロードできません。"
 
+#: zoo_service_loader.c:895
+msgid "%s The following file: %s cannot be found."
+msgstr ""
+
 #: zoo_service_loader.c:940
 #, c-format