Index: /trunk/zoo-project/zoo-kernel/Makefile.in
===================================================================
--- /trunk/zoo-project/zoo-kernel/Makefile.in	(revision 810)
+++ /trunk/zoo-project/zoo-kernel/Makefile.in	(revision 811)
@@ -61,4 +61,5 @@
 service_internal_ms.o: service_internal_ms.c
 	gcc ${JS_ENABLED} ${GDAL_CFLAGS}  ${JSCFLAGS} ${XML2CFLAGS} ${CFLAGS} -fPIC -c service_internal_ms.c
+	echo "SYMBOLSET\nEND" > sybols.sym
 
 service_internal_python.o: service_internal_python.c service.h
@@ -112,5 +113,5 @@
 	g++  ${XML2CFLAGS} ${CFLAGS} zcfg2yaml.o server_internal.o service_internal.o ${MS_FILE} response_print.o lex.cr.o lex.sr.o service_conf.tab.o main_conf_read.tab.o  ${YAML_FILE} -o zcfg2yaml -L. ${LDFLAGS}
 
-install:
+install: zoo_loader.cgi
 	install -d ${DESTDIR}${CGI_DIR}
 	install zoo_loader.cgi ${DESTDIR}${CGI_DIR}/
@@ -119,7 +120,8 @@
 	 if [ -e "libzoo_service.${EXT}" ]; then rm  libzoo_service.${EXT}; fi ; \
 	 ln -s ${LIBZOO_SERVICE} libzoo_service.${EXT})
+	if [ -z "${MS_FILE}" ] ; then echo "No symbols.sym" ; else install -d ${SHAREDSTATEDIR}; install symbols.sym ${SHAREDSTATEDIR}; fi
 	install -d ${DESTDIR}${INST_INCLUDE}/zoo
 	install sqlapi.h service.h service_internal.h ${DESTDIR}${INST_INCLUDE}/zoo
 
 clean:
-	rm -f version.h *.o *.zo *.eo *.tab.c *.tab.h *.sr.c* service_loader lex.* *.lreg *.sibling service_loader.dSYM *${EXT}
+	rm -f version.h symbols.sym *.o *.cgi *.eo *.tab.c *.tab.h *.sr.c* service_loader lex.* *.lreg *.sibling service_loader.dSYM *${EXT}
Index: /trunk/zoo-project/zoo-kernel/ZOOMakefile.opts.in
===================================================================
--- /trunk/zoo-project/zoo-kernel/ZOOMakefile.opts.in	(revision 810)
+++ /trunk/zoo-project/zoo-kernel/ZOOMakefile.opts.in	(revision 811)
@@ -105,2 +105,3 @@
 
 DATAROOTDIR=@datarootdir@/zoo-project
+SHAREDSTATEDIR=@sharedstatedir@/zoo-project
Index: unk/zoo-project/zoo-kernel/main.cfg
===================================================================
--- /trunk/zoo-project/zoo-kernel/main.cfg	(revision 810)
+++ 	(revision )
@@ -1,33 +1,0 @@
-[main]
-encoding = utf-8
-version = 1.0.0
-serverAddress = http://www.zoo-project.org/zoo/
-language = en-US
-lang = fr-FR,en-CA,en-US
-tmpPath=/tmp/
-tmpUrl = ../mpPathRelativeToServerAdress/
-dataPath = /tmp/
-cacheDir = /tmp/
-
-[identification]
-title = The Zoo WPS Development Server
-abstract = Development version of ZooWPS. See http://www.zoo-project.org
-fees = None
-accessConstraints = none
-keywords = WPS,GIS,buffer
-
-[provider]
-providerName=ZOO Project
-providerSite=http://www.zoo-project.org
-individualName=Gerald FENOY
-positionName=Developer
-role=Dev
-addressDeliveryPoint=1280, avenue des Platanes
-addressCity=Lattes
-addressAdministrativeArea=False
-addressPostalCode=34970
-addressCountry=fr
-addressElectronicMailAddress=gerald@geolabs.fr
-phoneVoice=False
-phoneFacsimile=False
-
Index: /trunk/zoo-project/zoo-kernel/main.cfg.in
===================================================================
--- /trunk/zoo-project/zoo-kernel/main.cfg.in	(revision 811)
+++ /trunk/zoo-project/zoo-kernel/main.cfg.in	(revision 811)
@@ -0,0 +1,33 @@
+[main]
+encoding = utf-8
+version = 1.0.0
+serverAddress = http://www.zoo-project.org/zoo/
+language = en-US
+lang = fr-FR,en-CA,en-US
+tmpPath=/tmp/
+tmpUrl = ../tmpPathRelativeToServerAdress/
+dataPath = @sharedstatedir@/zoo-project
+cacheDir = /tmp/
+
+[identification]
+title = The Zoo WPS Development Server
+abstract = Development version of ZooWPS. See http://www.zoo-project.org
+fees = None
+accessConstraints = none
+keywords = WPS,GIS,buffer
+
+[provider]
+providerName=ZOO Project
+providerSite=http://www.zoo-project.org
+individualName=Gerald FENOY
+positionName=Developer
+role=Dev
+addressDeliveryPoint=1280, avenue des Platanes
+addressCity=Lattes
+addressAdministrativeArea=False
+addressPostalCode=34970
+addressCountry=fr
+addressElectronicMailAddress=gerald@geolabs.fr
+phoneVoice=False
+phoneFacsimile=False
+
Index: /trunk/zoo-project/zoo-services/utils/status/Makefile
===================================================================
--- /trunk/zoo-project/zoo-services/utils/status/Makefile	(revision 810)
+++ /trunk/zoo-project/zoo-services/utils/status/Makefile	(revision 811)
@@ -8,5 +8,8 @@
 install:
 	install -d ${CGI_DIR}
-	install cgi-env/* ${CGI_DIR}/
+	install cgi-env/*.zcfg ${CGI_DIR}/
+	install cgi-env/*.zo ${CGI_DIR}/
+	install cgi-env/updateStatus.xsl ${SHAREDSTATEDIR}/
+
 clean:
 	rm -f cgi-env/wps_status.zo