Index: trunk/zoo-project/zoo-kernel/response_print.c
===================================================================
--- trunk/zoo-project/zoo-kernel/response_print.c	(revision 817)
+++ trunk/zoo-project/zoo-kernel/response_print.c	(revision 820)
@@ -1982,10 +1982,12 @@
     elements* ecurs=getElements(e,(e!=NULL?e->name:m->name));
     ecurs=ecurs->child;
-    while(curs!=NULL && ecurs!=NULL){
+    while(curs!=NULL){
+      ecurs=getElements(ecurs,(curs->name));
       map* inRequest=getMap(curs->content,"inRequest");
       if(inRequest!=NULL && strncasecmp(inRequest->value,"true",4)==0)
 	printIOType(doc,nc1,ns_wps,ns_ows,ns_xlink,ecurs,curs,type,vid);
       curs=curs->next;
-      ecurs=ecurs->next;
+      ecurs=getElements(e,(e!=NULL?e->name:m->name));
+      ecurs=ecurs->child;
     }
   }
Index: trunk/zoo-project/zoo-kernel/server_internal.c
===================================================================
--- trunk/zoo-project/zoo-kernel/server_internal.c	(revision 817)
+++ trunk/zoo-project/zoo-kernel/server_internal.c	(revision 820)
@@ -662,10 +662,16 @@
 	    if(tmpMaps2->content==NULL)
 	      tmpMaps2->content=createMap(tmpm->name,tmpm->value);
-	    else
+	    else{
 	      addToMap(tmpMaps2->content,tmpm->name,tmpm->value);
+	    }
 	    tmpm=tmpm->next;
 	  }
 	}
-	addToMap(tmpMaps2->content,"inRequest","false");
+	if(tmpMaps2->content==NULL){
+	  tmpMaps2->content=createMap("inRequest","false");
+	  dumpMaps(tmpMaps2);
+	}
+	else
+	  addToMap(tmpMaps2->content,"inRequest","false");
 	if(type==0){
 	  map *tmpMap=getMap(tmpMaps2->content,"value");
@@ -673,4 +679,12 @@
 	    addToMap(tmpMaps2->content,"value","NULL");
 	}
+	elements* tmpElements=getElements(in,tmpMaps2->name);
+	if(tmpElements!=NULL && tmpElements->child!=NULL){
+	  char *res=addDefaultValues(&tmpMaps2->child,tmpElements->child,m,type,err);
+	  if(strlen(res)>0){
+	    return res;
+	  }
+	}
+
 	if(out1==NULL){
 	  *out=dupMaps(&tmpMaps2);
@@ -687,5 +701,5 @@
       }
     }
-    else{
+    else { 
       iotype* tmpIoType=NULL;
       if(tmpMaps->content!=NULL){
@@ -820,21 +834,12 @@
 	addToMap(tmpMaps->content,"inRequest","true");
       elements* tmpElements=getElements(in,tmpMaps->name);
-      if(tmpMaps->child!=NULL && tmpElements!=NULL && tmpElements->child!=NULL){
+      if(tmpElements!=NULL && tmpElements->child!=NULL){
 	char *res=addDefaultValues(&tmpMaps->child,tmpElements->child,m,type,err);
 	if(strlen(res)>0){
-	  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
 	  return res;
 	}
       }
     }
-    if(tmpInputs->child!=NULL){
-      tmpInputss=tmpInputs->next;
-      tmpInputs=tmpInputs->child;
-      if(tmpMaps!=NULL){
-	out1=tmpMaps->child;
-	out1s=tmpMaps;
-      }
-    }else
-      tmpInputs=tmpInputs->next;
+    tmpInputs=tmpInputs->next;
   }
   if(tmpInputss!=NULL){
Index: trunk/zoo-project/zoo-kernel/ulinet.c
===================================================================
--- trunk/zoo-project/zoo-kernel/ulinet.c	(revision 817)
+++ trunk/zoo-project/zoo-kernel/ulinet.c	(revision 820)
@@ -191,9 +191,9 @@
  * @param proto the protocol requiring the use of a proxy
  */
-bool setProxiesForProtcol(CURL* handle,const char *proto){
+int setProxiesForProtcol(CURL* handle,const char *proto){
 #ifdef MSG_LAF_VERBOSE
   fprintf( stderr, "setProxiesForProtocol (do nothing) ...\n" );
 #endif
-  return true;
+  return 0;
 }
 #endif
@@ -284,5 +284,6 @@
     char *token, *saveptr;
     token = strtok_r (tmp, ",", &saveptr);
-    for(int i=0;i<handle->nb;i++){
+    int i;
+    for(i=0;i<handle->nb;i++){
       if(targetHosts->value[0]=='*' || isProtectedHost(targetHosts->value,handle->ihandle[i].url)==1){
 	while (token != NULL){
@@ -290,10 +291,11 @@
 	  char* tmp1=(char*)malloc(length*sizeof(char));
 	  snprintf(tmp1,6,"HTTP_");
-	  for(int i=0;token[i]!='\0';i++){
-	    if(token[i]!='-')
-	      tmp1[5+i]=toupper(token[i]);
+	  int j;
+	  for(j=0;token[j]!='\0';j++){
+	    if(token[j]!='-')
+	      tmp1[5+j]=toupper(token[i]);
 	    else
-	      tmp1[5+i]='_';
-	    tmp1[5+i+1]='\0';
+	      tmp1[5+j]='_';
+	    tmp1[5+j+1]='\0';
 	  }
 	  fprintf(stderr,"%s %d %s \n",__FILE__,__LINE__,tmp1);